package core
import scala.actors.Actor
import scala.util.Random

trait Customer {
  def buy() : Unit
}

class TCustomer(store : Store) extends Actor with Customer {
  
  val random = new Random()
  var items : Array[Item] = new Array[Item](0)
  store.enter
  def buy(): Unit = { items = store.buy() }
  
  override def toString = {
    var s = "(Customer\nItems: "
    items.toString
    s+=")"
    s
  }
  
  def act(){
    //Console.println(this)
    buy()
    //Thread.sleep(random.nextInt(100))
    //Console.println(this)
    
    val myCounter = Supermarket.getCounter
    myCounter.line ! StandInLine
    
    while (true) {
      receive {
        case YouAreNext => myCounter ! ImHere
        case GiveMeYourItems => myCounter ! Items(items)
        case Price(p) => myCounter ! Money(p)
        case GoodBye => {
          store.leave
          exit()
        }
      }
    }
  }

}