package core
import scala.util.Random

trait Store { 
  def buy() : Array[Item]
  def enter: Unit
  def leave : Unit
}


object Supermarket extends Store{
  
  val random = new Random()
 
  var nextid = 0
  var items  = List[(Item,Price)]()
  
  private def assignNextId() : Int = synchronized( {
    val id = nextid
    nextid += 1
    id
  })
  
  def getPrice(item : Item) : Price = {
    
    def f( i : Item, p: Price ) = {
      if (item.id == i.id) true
      else false
    }
    
    val o = items.find((f _).tupled)
    
    o match{
      case Some((_,p)) => p
      case None => Price(0)
    }
    
  }
  
  
  var counters = List[Counter]()
  
  def initCounters(c : Int) = {
    for (i<-List.range(0,c)) counters ::= new Counter()
  }
  def startCounters=( for (c<-counters) c.start)
  
  def getCounter = counters(random.nextInt(counters.length))
  
  var buyingcustomers = 0
  var payingcustomers = 0
  
  def enter = synchronized (buyingcustomers+=1) 
  def leave = synchronized ({
      payingcustomers-=1
      //checkClosingTime()
  	}
  )
  
  def checkClosingTime() = {
    if (buyingcustomers<=0 && payingcustomers<=0) close
  }
  
  def close = for (c<-counters) c ! Close
  
  //TODO move synch to assign def
  def  buy = {
    val quantity = random.nextInt(10)
    val a = new Array[Item](quantity)
    
    for (i<-List.range(0,quantity)){
      val genitem = new Item(assignNextId)      
      a.update(i,genitem)
      items ::= (genitem, Price(random.nextInt(100)+1))
    }
    
    a
  }

  
   var income = 0
  
  def book(q : Int) = income += q
  
  def storageSummedValue() = (for (i<- items) yield i._2.price) sum
    
  
}